from PyKDE4 import plasmascript
from PyKDE4.plasma import Plasma
from PyKDE4.kdeui import KIcon, KMessageBox
import mysql.connector
 
class QRRunner(plasmascript.Runner):
 
    def init(self):
        self.addSyntax(Plasma.RunnerSyntax("qr :q:", "Returns recipes containing the words :q:"))
 
    def match(self, context):
        # called by krunner to let us add actions for the user
        if not context.isValid():
            return
 
        q = context.query()
 
        # look for our keyword 'msg'
        if not q.startsWith("qr "):
             return
 
        # ignore less than 3 characters (in addition to the keyword)
        if q.length < 7:
            return
 
        # strip the keyword and leading space
        q = q[3:]
        q = q.trimmed()
        
	cnx = mysql.connector.connect(user='root',database='quickrecipe',password='inserthere')
	cursor = cnx.cursor()
	cursor.execute("SELECT name FROM recipes WHERE name LIKE '%"+q+"%'");
	for (name) in cursor:
	  m = Plasma.QueryMatch(self.runner)
	  m.setText("Recipe: %s" % name)
	  m.setType(Plasma.QueryMatch.ExactMatch)
	  m.setIcon(KIcon("dialog-information"))
	  m.setData(q)
	  context.addMatch(q, m)
	cursor.close()
	
def run(self, context, match):
        # called by KRunner when the user selects our action,        
        # so lets keep our promise
        KMessageBox.messageBox(None, KMessageBox.Information, match.data().toString())
        
def CreateRunner(parent):
    # called by krunner, must simply return an instance of the runner object
    return QRRunner(parent)